Imports System.Xml
Imports System.Web.UI.WebControls
Imports System.Data.SqlClient
Imports System.Web.Security

Public Class XmlToForm
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        If Page.IsPostBack = False Then

            ' When the page loads we get the user id from a session variable and saves this in a hidden field

            HiddenUserID.Value = Convert.ToString(Session("UserID"))

        End If

        If Page.IsPostBack = False Then

            If Not Context.Items("url") Is Nothing Then

                ' We get the url of the xml-file that we want to get data from. The url is sent to this page
                ' with a Server.Transfer that have used Context.Items.Add("url") to send the value. We get
                ' the value for the url by Context.Items("url")


                Dim XmlUrl As String = Convert.ToString(Context.Items("url"))

                ' We create a new XmlDocument to get data from a Xml-file and loads the file according to the path in "XmlUrl"
                Dim textReader As New XmlDocument()
                textReader.Load(Server.MapPath(XmlUrl))

                'Create an XmlNamespaceManager for resolving namespaces.
                Dim xbrli As XmlNamespaceManager = New XmlNamespaceManager(textReader.NameTable)
                Dim secdbase As XmlNamespaceManager = New XmlNamespaceManager(textReader.NameTable)
                Dim genbase As XmlNamespaceManager = New XmlNamespaceManager(textReader.NameTable)
                xbrli.AddNamespace("xbrli", "http://www.xbrl.org/2003/instance")
                secdbase.AddNamespace("se-cd-base", "http://www.xbrl.se/se/fr/cd-base/2007-05-25")
                genbase.AddNamespace("se-gen-base", "http://www.xbrl.se/se/fr/gen-base/2007-05-25")

                ' The root node for the document
                Dim root As XmlNode = textReader.DocumentElement

                ' General company and reporting information
                txtFirma.Text = root.SelectSingleNode("se-cd-base:Firma", secdbase).ChildNodes(0).Value
                txtOrganisationsnummer.Text = root.SelectSingleNode("se-cd-base:Organisationsnummer", secdbase).ChildNodes(0).Value
                txtBeloppsformat.SelectedValue = root.SelectSingleNode("se-cd-base:Beloppsformat", secdbase).ChildNodes(0).Value
                If txtBeloppsformat.SelectedValue = "NORMALFORM" Then
                    txtDecimals.Text = "INF"
                Else
                    txtDecimals.Text = "-3"
                End If
                txtRedovisningsvaluta.SelectedValue = root.SelectSingleNode("se-cd-base:Redovisningsvaluta", secdbase).ChildNodes(0).Value

                ' Reporting year, innevarande rakenskapsar, current year
                txtRakenskapsarStartDatePeriod0.Text = root.SelectSingleNode("//xbrli:context[@id='PERIOD0']//xbrli:startDate", xbrli).ChildNodes(0).Value
                txtRakenskapsarEndDatePeriod0.Text = root.SelectSingleNode("//xbrli:context[@id='PERIOD0']//xbrli:endDate", xbrli).ChildNodes(0).Value

                ' Comparing year, jamforelsear, previous year
                Dim StartPeriodM1 As XmlNode = root.SelectSingleNode("//xbrli:context[@id='PERIOD-1']//xbrli:startDate", xbrli)
                If Not StartPeriodM1 Is Nothing Then
                    txtRakenskapsarStartDatePeriodm1.Text = StartPeriodM1.ChildNodes(0).Value
                    StartPeriodM1 = Nothing
                End If
                Dim EndPeriodM1 As XmlNode = root.SelectSingleNode("//xbrli:context[@id='PERIOD-1']//xbrli:endDate", xbrli)
                If Not EndPeriodM1 Is Nothing Then
                    txtRakenskapsarEndDatePeriodm1.Text = EndPeriodM1.ChildNodes(0).Value
                    EndPeriodM1 = Nothing
                End If

                ' /////////////////////// Forvaltningsberattelsen ///////////////////
                Dim BusinessDescription As XmlNode = root.SelectSingleNode("se-gen-base:Verksamheten", genbase)
                If Not BusinessDescription Is Nothing Then
                    txtVerksamheten.Text = BusinessDescription.ChildNodes(0).Value
                    BusinessDescription = Nothing
                End If
                Dim ImportantEvents As XmlNode = root.SelectSingleNode("se-gen-base:VasentligaHandelserUnderOchEfterRakenskapsaretsSlut", genbase)
                If Not ImportantEvents Is Nothing Then
                    txtVasantligaHandelser.Text = ImportantEvents.ChildNodes(0).Value
                    ImportantEvents = Nothing
                End If
                Dim FutureDevelopment As XmlNode = root.SelectSingleNode("se-gen-base:FramtidaUtveckling", genbase)
                If Not FutureDevelopment Is Nothing Then
                    txtFramtidaUtveckling.Text = FutureDevelopment.ChildNodes(0).Value
                    FutureDevelopment = Nothing
                End If
                Dim EnvironmentPollution As XmlNode = root.SelectSingleNode("se-gen-base:Miljopaverkan", genbase)
                If Not EnvironmentPollution Is Nothing Then
                    txtMiljoPaverkan.Text = EnvironmentPollution.ChildNodes(0).Value
                    EnvironmentPollution = Nothing
                End If

                'Medel att disponera
                Dim MedelAttDisponeraOverkursfondObj As XmlNode = root.SelectSingleNode("se-gen-base:MedelAttDisponeraOverkursfond", genbase)
                If Not MedelAttDisponeraOverkursfondObj Is Nothing Then
                    MedelAttDisponeraOverkursfond.Text = MedelAttDisponeraOverkursfondObj.ChildNodes(0).Value
                    MedelAttDisponeraOverkursfondObj = Nothing
                End If
                Dim MedelAttDisponeraFondForVerkligtVardeObj As XmlNode = root.SelectSingleNode("se-gen-base:MedelAttDisponeraFondForVerkligtVarde", genbase)
                If Not MedelAttDisponeraFondForVerkligtVardeObj Is Nothing Then
                    MedelAttDisponeraFondForVerkligtVarde.Text = MedelAttDisponeraFondForVerkligtVardeObj.ChildNodes(0).Value
                    MedelAttDisponeraFondForVerkligtVardeObj = Nothing
                End If
                Dim MedelAttDisponeraBalanseratResultatObj As XmlNode = root.SelectSingleNode("se-gen-base:MedelAttDisponeraBalanseratResultat", genbase)
                If Not MedelAttDisponeraBalanseratResultatObj Is Nothing Then
                    MedelAttDisponeraBalanseratResultat.Text = MedelAttDisponeraBalanseratResultatObj.ChildNodes(0).Value
                    MedelAttDisponeraBalanseratResultatObj = Nothing
                End If
                Dim MedelAttDisponeraKoncernbidragObj As XmlNode = root.SelectSingleNode("se-gen-base:MedelAttDisponeraKoncernbidrag", genbase)
                If Not MedelAttDisponeraKoncernbidragObj Is Nothing Then
                    MedelAttDisponeraKoncernbidrag.Text = MedelAttDisponeraKoncernbidragObj.ChildNodes(0).Value
                    MedelAttDisponeraKoncernbidragObj = Nothing
                End If
                Dim MedelAttDisponeraErhallnaAktieagartillskottObj As XmlNode = root.SelectSingleNode("se-gen-base:MedelAttDisponeraErhallnaAktieagartillskott", genbase)
                If Not MedelAttDisponeraErhallnaAktieagartillskottObj Is Nothing Then
                    MedelAttDisponeraErhallnaAktieagartillskott.Text = MedelAttDisponeraErhallnaAktieagartillskottObj.ChildNodes(0).Value
                    MedelAttDisponeraErhallnaAktieagartillskottObj = Nothing
                End If
                Dim MedelAttDisponeraAretsResultatObj As XmlNode = root.SelectSingleNode("se-gen-base:MedelAttDisponeraAretsResultat", genbase)
                If Not MedelAttDisponeraAretsResultatObj Is Nothing Then
                    MedelAttDisponeraAretsResultat.Text = MedelAttDisponeraAretsResultatObj.ChildNodes(0).Value
                    MedelAttDisponeraAretsResultatObj = Nothing
                End If
                Dim MedelAttDisponeraObj As XmlNode = root.SelectSingleNode("se-gen-base:MedelAttDisponera", genbase)
                If Not MedelAttDisponeraObj Is Nothing Then
                    MedelAttDisponeraSumma.Text = MedelAttDisponeraObj.ChildNodes(0).Value
                    MedelAttDisponeraObj = Nothing
                End If

                ' Forslag till disposition
                Dim ForslagDispositionUtdelningObj As XmlNode = root.SelectSingleNode("se-gen-base:ForslagDispositionUtdelning", genbase)
                If Not ForslagDispositionUtdelningObj Is Nothing Then
                    ForslagDispositionUtdelning.Text = ForslagDispositionUtdelningObj.ChildNodes(0).Value
                    ForslagDispositionUtdelningObj = Nothing
                End If
                Dim ForslagDispositionFondemissionObj As XmlNode = root.SelectSingleNode("se-gen-base:ForslagDispositionFondemission", genbase)
                If Not ForslagDispositionFondemissionObj Is Nothing Then
                    ForslagDispositionFondemission.Text = ForslagDispositionFondemissionObj.ChildNodes(0).Value
                    ForslagDispositionFondemissionObj = Nothing
                End If
                Dim ForslagDispositionAvsattningTillReservfondObj As XmlNode = root.SelectSingleNode("se-gen-base:ForslagDispositionAvsattningReservfond", genbase)
                If Not ForslagDispositionAvsattningTillReservfondObj Is Nothing Then
                    ForslagDispositionAvsattningTillReservfond.Text = ForslagDispositionAvsattningTillReservfondObj.ChildNodes(0).Value
                    ForslagDispositionAvsattningTillReservfondObj = Nothing
                End If
                Dim ForslagDispositionIanspraktagandeAvReservFondObj As XmlNode = root.SelectSingleNode("se-gen-base:ForslagDispositionIanspraktagandeAvReservfond", genbase)
                If Not ForslagDispositionIanspraktagandeAvReservFondObj Is Nothing Then
                    ForslagDispositionIanspraktagandeAvReservFond.Text = ForslagDispositionIanspraktagandeAvReservFondObj.ChildNodes(0).Value
                    ForslagDispositionIanspraktagandeAvReservFondObj = Nothing
                End If
                Dim ForslagDispositionIanspraktagandeAvUppskrivningsfondObj As XmlNode = root.SelectSingleNode("se-gen-base:ForslagDispositionIanspraktagandeAvUppskrivningsfond", genbase)
                If Not ForslagDispositionIanspraktagandeAvUppskrivningsfondObj Is Nothing Then
                    ForslagDispositionIanspraktagandeAvUppskrivningsfond.Text = ForslagDispositionIanspraktagandeAvUppskrivningsfondObj.ChildNodes(0).Value
                    ForslagDispositionIanspraktagandeAvUppskrivningsfondObj = Nothing
                End If
                Dim ForslagDispositionBalanserasINyRakningObj As XmlNode = root.SelectSingleNode("se-gen-base:ForslagDispositionBalanserasINyRakning", genbase)
                If Not ForslagDispositionBalanserasINyRakningObj Is Nothing Then
                    ForslagDispositionBalanserasINyRakning.Text = ForslagDispositionBalanserasINyRakningObj.ChildNodes(0).Value
                    ForslagDispositionBalanserasINyRakningObj = Nothing
                End If
                Dim ForslagDispositionSummaObj As XmlNode = root.SelectSingleNode("se-gen-base:ForslagDispositionSumma", genbase)
                If Not ForslagDispositionSummaObj Is Nothing Then
                    ForslagDispositionSumma.Text = ForslagDispositionSummaObj.ChildNodes(0).Value
                    ForslagDispositionSummaObj = Nothing
                End If

                Dim txtKommentarDispositionerObj As XmlNode = root.SelectSingleNode("se-gen-base:DispositionerVinstEllerForlustKommentar", genbase)
                If Not txtKommentarDispositionerObj Is Nothing Then
                    txtKommentarDispositioner.Text = txtKommentarDispositionerObj.ChildNodes(0).Value
                    txtKommentarDispositionerObj = Nothing
                End If
                Dim StyrelsensYttrandeVinstutdelningObj As XmlNode = root.SelectSingleNode("se-gen-base:StyrelsensYttrandeVinstutdelning", genbase)
                If Not StyrelsensYttrandeVinstutdelningObj Is Nothing Then
                    StyrelsensYttrandeVinstutdelning.Text = StyrelsensYttrandeVinstutdelningObj.ChildNodes(0).Value
                    StyrelsensYttrandeVinstutdelningObj = Nothing
                End If
                Dim ResultatOchStallningObj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatOchStallning", genbase)
                If Not ResultatOchStallningObj Is Nothing Then
                    ResultatOchStallning.Text = ResultatOchStallningObj.ChildNodes(0).Value
                    ResultatOchStallningObj = Nothing
                End If

                ' ////////////////// Resultatrkning ////////////////////
                ' Rorelsens intakter
                Dim NettoomsattningRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:Nettoomsattning[@contextRef='PERIOD0']", genbase)
                If Not NettoomsattningRES0Obj Is Nothing Then
                    NettoomsattningRES0.Text = NettoomsattningRES0Obj.ChildNodes(0).Value
                    NettoomsattningRES0Obj = Nothing
                End If
                Dim NettoomsattningRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:Nettoomsattning[@contextRef='PERIOD-1']", genbase)
                If Not NettoomsattningRESm1Obj Is Nothing Then
                    NettoomsattningRESm1.Text = NettoomsattningRESm1Obj.ChildNodes(0).Value
                    NettoomsattningRESm1Obj = Nothing
                End If
                Dim KostnadSaldaVarorRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:KostnadSaldaVaror[@contextRef='PERIOD0']", genbase)
                If Not KostnadSaldaVarorRES0Obj Is Nothing Then
                    KostnadSaldaVarorRES0.Text = KostnadSaldaVarorRES0Obj.ChildNodes(0).Value
                    KostnadSaldaVarorRES0Obj = Nothing
                End If
                Dim KostnadSaldaVarorRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:KostnadSaldaVaror[@contextRef='PERIOD-1']", genbase)
                If Not KostnadSaldaVarorRESm1Obj Is Nothing Then
                    KostnadSaldaVarorRESm1.Text = KostnadSaldaVarorRESm1Obj.ChildNodes(0).Value
                    KostnadSaldaVarorRESm1Obj = Nothing
                End If
                Dim BruttoresultatRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:Bruttoresultat[@contextRef='PERIOD0']", genbase)
                If Not BruttoresultatRES0Obj Is Nothing Then
                    BruttoresultatRES0.Text = BruttoresultatRES0Obj.ChildNodes(0).Value
                    BruttoresultatRES0Obj = Nothing
                End If
                Dim BruttoresultatRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:Bruttoresultat[@contextRef='PERIOD-1']", genbase)
                If Not BruttoresultatRESm1Obj Is Nothing Then
                    BruttoresultatRESm1.Text = BruttoresultatRESm1Obj.ChildNodes(0).Value
                    BruttoresultatRESm1Obj = Nothing
                End If
                Dim ForsaljningskostnaderRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:Forsaljningskostnader[@contextRef='PERIOD0']", genbase)
                If Not ForsaljningskostnaderRES0Obj Is Nothing Then
                    ForsaljningskostnaderRES0.Text = ForsaljningskostnaderRES0Obj.ChildNodes(0).Value
                    ForsaljningskostnaderRES0Obj = Nothing
                End If
                Dim ForsaljningskostnaderRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:Forsaljningskostnader[@contextRef='PERIOD-1']", genbase)
                If Not ForsaljningskostnaderRESm1Obj Is Nothing Then
                    ForsaljningskostnaderRESm1.Text = ForsaljningskostnaderRESm1Obj.ChildNodes(0).Value
                    ForsaljningskostnaderRESm1Obj = Nothing
                End If
                Dim AdministrationskostnaderRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:Administrationskostnader[@contextRef='PERIOD0']", genbase)
                If Not AdministrationskostnaderRES0Obj Is Nothing Then
                    AdministrationskostnaderRES0.Text = AdministrationskostnaderRES0Obj.ChildNodes(0).Value
                    AdministrationskostnaderRES0Obj = Nothing
                End If
                Dim AdministrationskostnaderRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:Administrationskostnader[@contextRef='PERIOD-1']", genbase)
                If Not AdministrationskostnaderRESm1Obj Is Nothing Then
                    AdministrationskostnaderRESm1.Text = AdministrationskostnaderRESm1Obj.ChildNodes(0).Value
                    AdministrationskostnaderRESm1Obj = Nothing
                End If
                Dim ForskningUtvecklingRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ForskningsUtvecklingskostnader[@contextRef='PERIOD0']", genbase)
                If Not ForskningUtvecklingRES0Obj Is Nothing Then
                    ForskningUtvecklingRES0.Text = ForskningUtvecklingRES0Obj.ChildNodes(0).Value
                    ForskningUtvecklingRES0Obj = Nothing
                End If
                Dim ForskningUtvecklingRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ForskningsUtvecklingskostnader[@contextRef='PERIOD-1']", genbase)
                If Not ForskningUtvecklingRESm1Obj Is Nothing Then
                    ForskningUtvecklingRESm1.Text = ForskningUtvecklingRESm1Obj.ChildNodes(0).Value
                    ForskningUtvecklingRESm1Obj = Nothing
                End If
                Dim LagerforandringRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ForandringAvLagerAvProdukterIArbeteFardigaVarorOchPagaendeArbetenForAnnansRakning[@contextRef='PERIOD0']", genbase)
                If Not LagerforandringRES0Obj Is Nothing Then
                    LagerforandringRES0.Text = LagerforandringRES0Obj.ChildNodes(0).Value
                    LagerforandringRES0Obj = Nothing
                End If
                Dim LagerforandringRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ForandringAvLagerAvProdukterIArbeteFardigaVarorOchPagaendeArbetenForAnnansRakning[@contextRef='PERIOD-1']", genbase)
                If Not LagerforandringRESm1Obj Is Nothing Then
                    LagerforandringRESm1.Text = LagerforandringRESm1Obj.ChildNodes(0).Value
                    LagerforandringRESm1Obj = Nothing
                End If
                Dim AktiveratArbeteForEgenRakningRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:AktiveratArbeteForEgenRakning[@contextRef='PERIOD0']", genbase)
                If Not AktiveratArbeteForEgenRakningRES0Obj Is Nothing Then
                    AktiveratArbeteForEgenRakningRES0.Text = AktiveratArbeteForEgenRakningRES0Obj.ChildNodes(0).Value
                    AktiveratArbeteForEgenRakningRES0Obj = Nothing
                End If
                Dim AktiveratArbeteForEgenRakningRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:AktiveratArbeteForEgenRakning[@contextRef='PERIOD-1']", genbase)
                If Not AktiveratArbeteForEgenRakningRESm1Obj Is Nothing Then
                    AktiveratArbeteForEgenRakningRESm1.Text = AktiveratArbeteForEgenRakningRESm1Obj.ChildNodes(0).Value
                    AktiveratArbeteForEgenRakningRESm1Obj = Nothing
                End If
                Dim OvrigaRorelseIntakterRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaRorelseintakter[@contextRef='PERIOD0']", genbase)
                If Not OvrigaRorelseIntakterRES0Obj Is Nothing Then
                    OvrigaRorelseIntakterRES0.Text = OvrigaRorelseIntakterRES0Obj.ChildNodes(0).Value
                    OvrigaRorelseIntakterRES0Obj = Nothing
                End If
                Dim OvrigaRorelseIntakterRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaRorelseintakter[@contextRef='PERIOD-1']", genbase)
                If Not OvrigaRorelseIntakterRESm1Obj Is Nothing Then
                    OvrigaRorelseIntakterRESm1.Text = OvrigaRorelseIntakterRESm1Obj.ChildNodes(0).Value
                    OvrigaRorelseIntakterRESm1Obj = Nothing
                End If
                Dim RorelseintakterLagerforandringarMmRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:RorelseintakterLagerforandringarMm[@contextRef='PERIOD0']", genbase)
                If Not RorelseintakterLagerforandringarMmRES0Obj Is Nothing Then
                    RorelseintakterLagerforandringarMmRES0.Text = RorelseintakterLagerforandringarMmRES0Obj.ChildNodes(0).Value
                    RorelseintakterLagerforandringarMmRES0Obj = Nothing
                End If
                Dim RorelseintakterLagerforandringarMmRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:RorelseintakterLagerforandringarMm[@contextRef='PERIOD-1']", genbase)
                If Not RorelseintakterLagerforandringarMmRESm1Obj Is Nothing Then
                    RorelseintakterLagerforandringarMmRESm1.Text = RorelseintakterLagerforandringarMmRESm1Obj.ChildNodes(0).Value
                    RorelseintakterLagerforandringarMmRESm1Obj = Nothing
                End If

                ' Rorelsens kostnader
                Dim RavarorOchFornodenheterResultatrakningenRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:RavarorFornodenheterResultatrakningen[@contextRef='PERIOD0']", genbase)
                If Not RavarorOchFornodenheterResultatrakningenRES0Obj Is Nothing Then
                    RavarorOchFornodenheterResultatrakningenRES0.Text = RavarorOchFornodenheterResultatrakningenRES0Obj.ChildNodes(0).Value
                    RavarorOchFornodenheterResultatrakningenRES0Obj = Nothing
                End If
                Dim RavarorOchFornodenheterResultatrakningenRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:RavarorFornodenheterResultatrakningen[@contextRef='PERIOD-1']", genbase)
                If Not RavarorOchFornodenheterResultatrakningenRESm1Obj Is Nothing Then
                    RavarorOchFornodenheterResultatrakningenRESm1.Text = RavarorOchFornodenheterResultatrakningenRESm1Obj.ChildNodes(0).Value
                    RavarorOchFornodenheterResultatrakningenRESm1Obj = Nothing
                End If
                Dim HandelsvarorRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:Handelsvaror[@contextRef='PERIOD0']", genbase)
                If Not HandelsvarorRES0Obj Is Nothing Then
                    HandelsvarorRES0.Text = HandelsvarorRES0Obj.ChildNodes(0).Value
                    HandelsvarorRES0Obj = Nothing
                End If
                Dim HandelsvarorRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:Handelsvaror[@contextRef='PERIOD-1']", genbase)
                If Not HandelsvarorRESm1Obj Is Nothing Then
                    HandelsvarorRESm1.Text = HandelsvarorRESm1Obj.ChildNodes(0).Value
                    HandelsvarorRESm1Obj = Nothing
                End If
                Dim OvrigaExternaKostnaderRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaExternaKostnader[@contextRef='PERIOD0']", genbase)
                If Not OvrigaExternaKostnaderRES0Obj Is Nothing Then
                    OvrigaExternaKostnaderRES0.Text = OvrigaExternaKostnaderRES0Obj.ChildNodes(0).Value
                    OvrigaExternaKostnaderRES0Obj = Nothing
                End If
                Dim OvrigaExternaKostnaderRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaExternaKostnader[@contextRef='PERIOD-1']", genbase)
                If Not OvrigaExternaKostnaderRESm1Obj Is Nothing Then
                    OvrigaExternaKostnaderRESm1.Text = OvrigaExternaKostnaderRESm1Obj.ChildNodes(0).Value
                    OvrigaExternaKostnaderRESm1Obj = Nothing
                End If
                Dim PersonalkostnaderRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:Personalkostnader[@contextRef='PERIOD0']", genbase)
                If Not PersonalkostnaderRES0Obj Is Nothing Then
                    PersonalkostnaderRES0.Text = PersonalkostnaderRES0Obj.ChildNodes(0).Value
                    PersonalkostnaderRES0Obj = Nothing
                End If
                Dim PersonalkostnaderRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:Personalkostnader[@contextRef='PERIOD-1']", genbase)
                If Not PersonalkostnaderRESm1Obj Is Nothing Then
                    PersonalkostnaderRESm1.Text = PersonalkostnaderRESm1Obj.ChildNodes(0).Value
                    PersonalkostnaderRESm1Obj = Nothing
                End If
                Dim AvskrivningarOchNedskrivningarAvMateriellaOchImmateriellaAnlaggningstillgangarRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:AvskrivningarOchNedskrivningarMateriellaOchImmateriellaAnlaggningstillgangar[@contextRef='PERIOD0']", genbase)
                If Not AvskrivningarOchNedskrivningarAvMateriellaOchImmateriellaAnlaggningstillgangarRES0Obj Is Nothing Then
                    AvskrivningarOchNedskrivningarAvMateriellaOchImmateriellaAnlaggningstillgangarRES0.Text = AvskrivningarOchNedskrivningarAvMateriellaOchImmateriellaAnlaggningstillgangarRES0Obj.ChildNodes(0).Value
                    AvskrivningarOchNedskrivningarAvMateriellaOchImmateriellaAnlaggningstillgangarRES0Obj = Nothing
                End If
                Dim AvskrivningarOchNedskrivningarAvMateriellaOchImmateriellaAnlaggningstillgangarRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:AvskrivningarOchNedskrivningarMateriellaOchImmateriellaAnlaggningstillgangar[@contextRef='PERIOD-1']", genbase)
                If Not AvskrivningarOchNedskrivningarAvMateriellaOchImmateriellaAnlaggningstillgangarRESm1Obj Is Nothing Then
                    AvskrivningarOchNedskrivningarAvMateriellaOchImmateriellaAnlaggningstillgangarRESm1.Text = AvskrivningarOchNedskrivningarAvMateriellaOchImmateriellaAnlaggningstillgangarRESm1Obj.ChildNodes(0).Value
                    AvskrivningarOchNedskrivningarAvMateriellaOchImmateriellaAnlaggningstillgangarRESm1Obj = Nothing
                End If
                Dim NedskrivningarAvOmsattningstillgangarUtoverNormalaNedskrivningarRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:NedskrivningarOmsattningstillgangarUtoverNormalaNedskrivningar[@contextRef='PERIOD0']", genbase)
                If Not NedskrivningarAvOmsattningstillgangarUtoverNormalaNedskrivningarRES0Obj Is Nothing Then
                    NedskrivningarAvOmsattningstillgangarUtoverNormalaNedskrivningarRES0.Text = NedskrivningarAvOmsattningstillgangarUtoverNormalaNedskrivningarRES0Obj.ChildNodes(0).Value
                    NedskrivningarAvOmsattningstillgangarUtoverNormalaNedskrivningarRES0Obj = Nothing
                End If
                Dim NedskrivningarAvOmsattningstillgangarUtoverNormalaNedskrivningarRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:NedskrivningarOmsattningstillgangarUtoverNormalaNedskrivningar[@contextRef='PERIOD-1']", genbase)
                If Not NedskrivningarAvOmsattningstillgangarUtoverNormalaNedskrivningarRESm1Obj Is Nothing Then
                    NedskrivningarAvOmsattningstillgangarUtoverNormalaNedskrivningarRESm1.Text = NedskrivningarAvOmsattningstillgangarUtoverNormalaNedskrivningarRESm1Obj.ChildNodes(0).Value
                    NedskrivningarAvOmsattningstillgangarUtoverNormalaNedskrivningarRESm1Obj = Nothing
                End If
                Dim OvrigaRorelsekostnaderRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaRorelsekostnader[@contextRef='PERIOD0']", genbase)
                If Not OvrigaRorelsekostnaderRES0Obj Is Nothing Then
                    OvrigaRorelsekostnaderRES0.Text = OvrigaRorelsekostnaderRES0Obj.ChildNodes(0).Value
                    OvrigaRorelsekostnaderRES0Obj = Nothing
                End If
                Dim OvrigaRorelsekostnaderRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaRorelsekostnader[@contextRef='PERIOD-1']", genbase)
                If Not OvrigaRorelsekostnaderRESm1Obj Is Nothing Then
                    OvrigaRorelsekostnaderRESm1.Text = OvrigaRorelsekostnaderRESm1Obj.ChildNodes(0).Value
                    OvrigaRorelsekostnaderRESm1Obj = Nothing
                End If
                Dim SummaFunktionerRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:FunktionerMmSumma[@contextRef='PERIOD0']", genbase)
                If Not SummaFunktionerRES0Obj Is Nothing Then
                    SummaFunktionerRES0.Text = SummaFunktionerRES0Obj.ChildNodes(0).Value
                    SummaFunktionerRES0Obj = Nothing
                End If
                Dim SummaFunktionerRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:FunktionerMmSumma[@contextRef='PERIOD-1']", genbase)
                If Not SummaFunktionerRESm1Obj Is Nothing Then
                    SummaFunktionerRESm1.Text = SummaFunktionerRESm1Obj.ChildNodes(0).Value
                    SummaFunktionerRESm1Obj = Nothing
                End If
                Dim RorelsekostnaderRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:Rorelsekostnader[@contextRef='PERIOD0']", genbase)
                If Not RorelsekostnaderRES0Obj Is Nothing Then
                    RorelsekostnaderRES0.Text = RorelsekostnaderRES0Obj.ChildNodes(0).Value
                    RorelsekostnaderRES0Obj = Nothing
                End If
                Dim RorelsekostnaderRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:Rorelsekostnader[@contextRef='PERIOD-1']", genbase)
                If Not RorelsekostnaderRESm1Obj Is Nothing Then
                    RorelsekostnaderRESm1.Text = RorelsekostnaderRESm1Obj.ChildNodes(0).Value
                    RorelsekostnaderRESm1Obj = Nothing
                End If

                Dim RorelseresultatRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:Rorelseresultat[@contextRef='PERIOD0']", genbase)
                If Not RorelseresultatRES0Obj Is Nothing Then
                    RorelseresultatRES0.Text = RorelseresultatRES0Obj.ChildNodes(0).Value
                    RorelseresultatRES0Obj = Nothing
                End If
                Dim RorelseresultatRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:Rorelseresultat[@contextRef='PERIOD-1']", genbase)
                If Not RorelseresultatRESm1Obj Is Nothing Then
                    RorelseresultatRESm1.Text = RorelseresultatRESm1Obj.ChildNodes(0).Value
                    RorelseresultatRESm1Obj = Nothing
                End If

                ' Finansiella poster
                Dim ResultatFranAndelarIKoncernforetagRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatAndelarKoncernforetag[@contextRef='PERIOD0']", genbase)
                If Not ResultatFranAndelarIKoncernforetagRES0Obj Is Nothing Then
                    ResultatFranAndelarIKoncernforetagRES0.Text = ResultatFranAndelarIKoncernforetagRES0Obj.ChildNodes(0).Value
                    ResultatFranAndelarIKoncernforetagRES0Obj = Nothing
                End If
                Dim ResultatFranAndelarIKoncernforetagRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatAndelarKoncernforetag[@contextRef='PERIOD-1']", genbase)
                If Not ResultatFranAndelarIKoncernforetagRESm1Obj Is Nothing Then
                    ResultatFranAndelarIKoncernforetagRESm1.Text = ResultatFranAndelarIKoncernforetagRESm1Obj.ChildNodes(0).Value
                    ResultatFranAndelarIKoncernforetagRESm1Obj = Nothing
                End If
                Dim ResultatFranAndelarIIntresseforetagRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatAndelarIntresseforetag[@contextRef='PERIOD0']", genbase)
                If Not ResultatFranAndelarIIntresseforetagRES0Obj Is Nothing Then
                    ResultatFranAndelarIIntresseforetagRES0.Text = ResultatFranAndelarIIntresseforetagRES0Obj.ChildNodes(0).Value
                    ResultatFranAndelarIIntresseforetagRES0Obj = Nothing
                End If
                Dim ResultatFranAndelarIIntresseforetagRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatAndelarIntresseforetag[@contextRef='PERIOD-1']", genbase)
                If Not ResultatFranAndelarIIntresseforetagRESm1Obj Is Nothing Then
                    ResultatFranAndelarIIntresseforetagRESm1.Text = ResultatFranAndelarIIntresseforetagRESm1Obj.ChildNodes(0).Value
                    ResultatFranAndelarIIntresseforetagRESm1Obj = Nothing
                End If
                Dim ResultatFranOvrigaFinansiellaAnlaggningstillgangarRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatOvrigaFinansiellaAnlaggningstillgangar[@contextRef='PERIOD0']", genbase)
                If Not ResultatFranOvrigaFinansiellaAnlaggningstillgangarRES0Obj Is Nothing Then
                    ResultatFranOvrigaFinansiellaAnlaggningstillgangarRES0.Text = ResultatFranOvrigaFinansiellaAnlaggningstillgangarRES0Obj.ChildNodes(0).Value
                    ResultatFranOvrigaFinansiellaAnlaggningstillgangarRES0Obj = Nothing
                End If
                Dim ResultatFranOvrigaFinansiellaAnlaggningstillgangarRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatOvrigaFinansiellaAnlaggningstillgangar[@contextRef='PERIOD-1']", genbase)
                If Not ResultatFranOvrigaFinansiellaAnlaggningstillgangarRESm1Obj Is Nothing Then
                    ResultatFranOvrigaFinansiellaAnlaggningstillgangarRESm1.Text = ResultatFranOvrigaFinansiellaAnlaggningstillgangarRESm1Obj.ChildNodes(0).Value
                    ResultatFranOvrigaFinansiellaAnlaggningstillgangarRESm1Obj = Nothing
                End If
                Dim OvrigaRanteintakterOchLiknandeResultatposterRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaRanteintakterOchLiknandeResultatposter[@contextRef='PERIOD0']", genbase)
                If Not OvrigaRanteintakterOchLiknandeResultatposterRES0Obj Is Nothing Then
                    OvrigaRanteintakterOchLiknandeResultatposterRES0.Text = OvrigaRanteintakterOchLiknandeResultatposterRES0Obj.ChildNodes(0).Value
                    OvrigaRanteintakterOchLiknandeResultatposterRES0Obj = Nothing
                End If
                Dim OvrigaRanteintakterOchLiknandeResultatposterRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaRanteintakterOchLiknandeResultatposter[@contextRef='PERIOD-1']", genbase)
                If Not OvrigaRanteintakterOchLiknandeResultatposterRESm1Obj Is Nothing Then
                    OvrigaRanteintakterOchLiknandeResultatposterRESm1.Text = OvrigaRanteintakterOchLiknandeResultatposterRESm1Obj.ChildNodes(0).Value
                    OvrigaRanteintakterOchLiknandeResultatposterRESm1Obj = Nothing
                End If
                Dim NedskrivningarAvFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringarRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:NedskrivningarFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringar[@contextRef='PERIOD0']", genbase)
                If Not NedskrivningarAvFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringarRES0Obj Is Nothing Then
                    NedskrivningarAvFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringarRES0.Text = NedskrivningarAvFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringarRES0Obj.ChildNodes(0).Value
                    NedskrivningarAvFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringarRES0Obj = Nothing
                End If
                Dim NedskrivningarAvFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringarRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:NedskrivningarFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringar[@contextRef='PERIOD-1']", genbase)
                If Not NedskrivningarAvFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringarRESm1Obj Is Nothing Then
                    NedskrivningarAvFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringarRESm1.Text = NedskrivningarAvFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringarRESm1Obj.ChildNodes(0).Value
                    NedskrivningarAvFinansiellaAnlaggningstillgangarOchKortfristigaPlaceringarRESm1Obj = Nothing
                End If
                Dim RantekostnaderOchLiknandeResultatposterRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:RantekostnaderOchLiknandeResultatposter[@contextRef='PERIOD0']", genbase)
                If Not RantekostnaderOchLiknandeResultatposterRES0Obj Is Nothing Then
                    RantekostnaderOchLiknandeResultatposterRES0.Text = RantekostnaderOchLiknandeResultatposterRES0Obj.ChildNodes(0).Value
                    RantekostnaderOchLiknandeResultatposterRES0Obj = Nothing
                End If
                Dim RantekostnaderOchLiknandeResultatposterRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:RantekostnaderOchLiknandeResultatposter[@contextRef='PERIOD-1']", genbase)
                If Not RantekostnaderOchLiknandeResultatposterRESm1Obj Is Nothing Then
                    RantekostnaderOchLiknandeResultatposterRESm1.Text = RantekostnaderOchLiknandeResultatposterRESm1Obj.ChildNodes(0).Value
                    RantekostnaderOchLiknandeResultatposterRESm1Obj = Nothing
                End If
                Dim SummaFinPosterRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:FinansiellaPosterSumma[@contextRef='PERIOD0']", genbase)
                If Not SummaFinPosterRES0Obj Is Nothing Then
                    SummaFinPosterRES0.Text = SummaFinPosterRES0Obj.ChildNodes(0).Value
                    SummaFinPosterRES0Obj = Nothing
                End If
                Dim SummaFinPosterRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:FinansiellaPosterSumma[@contextRef='PERIOD-1']", genbase)
                If Not SummaFinPosterRESm1Obj Is Nothing Then
                    SummaFinPosterRESm1.Text = SummaFinPosterRESm1Obj.ChildNodes(0).Value
                    SummaFinPosterRESm1Obj = Nothing
                End If

                Dim ResultatEfterFinansiellaPosterRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatEfterFinansiellaPoster[@contextRef='PERIOD0']", genbase)
                If Not ResultatEfterFinansiellaPosterRES0Obj Is Nothing Then
                    ResultatEfterFinansiellaPosterRES0.Text = ResultatEfterFinansiellaPosterRES0Obj.ChildNodes(0).Value
                    ResultatEfterFinansiellaPosterRES0Obj = Nothing
                End If
                Dim ResultatEfterFinansiellaPosterRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatEfterFinansiellaPoster[@contextRef='PERIOD-1']", genbase)
                If Not ResultatEfterFinansiellaPosterRESm1Obj Is Nothing Then
                    ResultatEfterFinansiellaPosterRESm1.Text = ResultatEfterFinansiellaPosterRESm1Obj.ChildNodes(0).Value
                    ResultatEfterFinansiellaPosterRESm1Obj = Nothing
                End If

                ' Extraordinara poster
                Dim ExtraordinaraIntakterRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ExtraordinaraIntakter[@contextRef='PERIOD0']", genbase)
                If Not ExtraordinaraIntakterRES0Obj Is Nothing Then
                    ExtraordinaraIntakterRES0.Text = ExtraordinaraIntakterRES0Obj.ChildNodes(0).Value
                    ExtraordinaraIntakterRES0Obj = Nothing
                End If
                Dim ExtraordinaraIntakterRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ExtraordinaraIntakter[@contextRef='PERIOD-1']", genbase)
                If Not ExtraordinaraIntakterRESm1Obj Is Nothing Then
                    ExtraordinaraIntakterRESm1.Text = ExtraordinaraIntakterRESm1Obj.ChildNodes(0).Value
                    ExtraordinaraIntakterRESm1Obj = Nothing
                End If
                Dim ExtraordinaraKostnaderRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ExtraordinaraKostnader[@contextRef='PERIOD0']", genbase)
                If Not ExtraordinaraKostnaderRES0Obj Is Nothing Then
                    ExtraordinaraKostnaderRES0.Text = ExtraordinaraKostnaderRES0Obj.ChildNodes(0).Value
                    ExtraordinaraKostnaderRES0Obj = Nothing
                End If
                Dim ExtraordinaraKostnaderRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ExtraordinaraKostnader[@contextRef='PERIOD-1']", genbase)
                If Not ExtraordinaraKostnaderRESm1Obj Is Nothing Then
                    ExtraordinaraKostnaderRESm1.Text = ExtraordinaraKostnaderRESm1Obj.ChildNodes(0).Value
                    ExtraordinaraKostnaderRESm1Obj = Nothing
                End If

                Dim ResultatForeBokslutsdispositionerOchSkattRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatForeBokslutsdispositionerOchSkatt[@contextRef='PERIOD0']", genbase)
                If Not ResultatForeBokslutsdispositionerOchSkattRES0Obj Is Nothing Then
                    ResultatForeBokslutsdispositionerOchSkattRES0.Text = ResultatForeBokslutsdispositionerOchSkattRES0Obj.ChildNodes(0).Value
                    ResultatForeBokslutsdispositionerOchSkattRES0Obj = Nothing
                End If
                Dim ResultatForeBokslutsdispositionerOchSkattRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatForeBokslutsdispositionerOchSkatt[@contextRef='PERIOD-1']", genbase)
                If Not ResultatForeBokslutsdispositionerOchSkattRESm1Obj Is Nothing Then
                    ResultatForeBokslutsdispositionerOchSkattRESm1.Text = ResultatForeBokslutsdispositionerOchSkattRESm1Obj.ChildNodes(0).Value
                    ResultatForeBokslutsdispositionerOchSkattRESm1Obj = Nothing
                End If

                ' Bokslutsdispositioner
                Dim ForandringAvPeriodiseringsfondRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ForandringPeriodiseringsfond[@contextRef='PERIOD0']", genbase)
                If Not ForandringAvPeriodiseringsfondRES0Obj Is Nothing Then
                    ForandringAvPeriodiseringsfondRES0.Text = ForandringAvPeriodiseringsfondRES0Obj.ChildNodes(0).Value
                    ForandringAvPeriodiseringsfondRES0Obj = Nothing
                End If
                Dim ForandringAvPeriodiseringsfondRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ForandringPeriodiseringsfond[@contextRef='PERIOD-1']", genbase)
                If Not ForandringAvPeriodiseringsfondRESm1Obj Is Nothing Then
                    ForandringAvPeriodiseringsfondRESm1.Text = ForandringAvPeriodiseringsfondRESm1Obj.ChildNodes(0).Value
                    ForandringAvPeriodiseringsfondRESm1Obj = Nothing
                End If
                Dim ForandringAvOveravskrivningarRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ForandringOveravskrivningar[@contextRef='PERIOD0']", genbase)
                If Not ForandringAvOveravskrivningarRES0Obj Is Nothing Then
                    ForandringAvOveravskrivningarRES0.Text = ForandringAvOveravskrivningarRES0Obj.ChildNodes(0).Value
                    ForandringAvOveravskrivningarRES0Obj = Nothing
                End If
                Dim ForandringAvOveravskrivningarRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ForandringOveravskrivningar[@contextRef='PERIOD-1']", genbase)
                If Not ForandringAvOveravskrivningarRESm1Obj Is Nothing Then
                    ForandringAvOveravskrivningarRESm1.Text = ForandringAvOveravskrivningarRESm1Obj.ChildNodes(0).Value
                    ForandringAvOveravskrivningarRESm1Obj = Nothing
                End If
                Dim ErhallnaKoncernbidragRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ErhallnaKoncernbidrag[@contextRef='PERIOD0']", genbase)
                If Not ErhallnaKoncernbidragRES0Obj Is Nothing Then
                    ErhallnaKoncernbidragRES0.Text = ErhallnaKoncernbidragRES0Obj.ChildNodes(0).Value
                    ErhallnaKoncernbidragRES0Obj = Nothing
                End If
                Dim ErhallnaKoncernbidragRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ErhallnaKoncernbidrag[@contextRef='PERIOD-1']", genbase)
                If Not ErhallnaKoncernbidragRESm1Obj Is Nothing Then
                    ErhallnaKoncernbidragRESm1.Text = ErhallnaKoncernbidragRESm1Obj.ChildNodes(0).Value
                    ErhallnaKoncernbidragRESm1Obj = Nothing
                End If
                Dim LamnadeKoncernbidragRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:LamnadeKoncernbidrag[@contextRef='PERIOD0']", genbase)
                If Not LamnadeKoncernbidragRES0Obj Is Nothing Then
                    LamnadeKoncernbidragRES0.Text = LamnadeKoncernbidragRES0Obj.ChildNodes(0).Value
                    LamnadeKoncernbidragRES0Obj = Nothing
                End If
                Dim LamnadeKoncernbidragRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:LamnadeKoncernbidrag[@contextRef='PERIOD-1']", genbase)
                If Not LamnadeKoncernbidragRESm1Obj Is Nothing Then
                    LamnadeKoncernbidragRESm1.Text = LamnadeKoncernbidragRESm1Obj.ChildNodes(0).Value
                    LamnadeKoncernbidragRESm1Obj = Nothing
                End If
                Dim OvrigaBokslutsdispositionerRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaBokslutsdispositioner[@contextRef='PERIOD0']", genbase)
                If Not OvrigaBokslutsdispositionerRES0Obj Is Nothing Then
                    OvrigaBokslutsdispositionerRES0.Text = OvrigaBokslutsdispositionerRES0Obj.ChildNodes(0).Value
                    OvrigaBokslutsdispositionerRES0Obj = Nothing
                End If
                Dim OvrigaBokslutsdispositionerRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaBokslutsdispositioner[@contextRef='PERIOD-1']", genbase)
                If Not OvrigaBokslutsdispositionerRESm1Obj Is Nothing Then
                    OvrigaBokslutsdispositionerRESm1.Text = OvrigaBokslutsdispositionerRESm1Obj.ChildNodes(0).Value
                    OvrigaBokslutsdispositionerRESm1Obj = Nothing
                End If
                Dim SummaBokslutsdispositionerRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:BokslutsdispositionerSumma[@contextRef='PERIOD0']", genbase)
                If Not SummaBokslutsdispositionerRES0Obj Is Nothing Then
                    SummaBokslutsdispositionerRES0.Text = SummaBokslutsdispositionerRES0Obj.ChildNodes(0).Value
                    SummaBokslutsdispositionerRES0Obj = Nothing
                End If
                Dim SummaBokslutsdispositionerRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:BokslutsdispositionerSumma[@contextRef='PERIOD-1']", genbase)
                If Not SummaBokslutsdispositionerRESm1Obj Is Nothing Then
                    SummaBokslutsdispositionerRESm1.Text = SummaBokslutsdispositionerRESm1Obj.ChildNodes(0).Value
                    SummaBokslutsdispositionerRESm1Obj = Nothing
                End If
                Dim ResultatForeSkattRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatForeSkatt[@contextRef='PERIOD0']", genbase)
                If Not ResultatForeSkattRES0Obj Is Nothing Then
                    ResultatForeSkattRES0.Text = ResultatForeSkattRES0Obj.ChildNodes(0).Value
                    ResultatForeSkattRES0Obj = Nothing
                End If
                Dim ResultatForeSkattRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:ResultatForeSkatt[@contextRef='PERIOD-1']", genbase)
                If Not ResultatForeSkattRESm1Obj Is Nothing Then
                    ResultatForeSkattRESm1.Text = ResultatForeSkattRESm1Obj.ChildNodes(0).Value
                    ResultatForeSkattRESm1Obj = Nothing
                End If

                ' Skatter och arets resultat
                Dim SkattPaAretsResultatRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:SkattAretsResultat[@contextRef='PERIOD0']", genbase)
                If Not SkattPaAretsResultatRES0Obj Is Nothing Then
                    SkattPaAretsResultatRES0.Text = SkattPaAretsResultatRES0Obj.ChildNodes(0).Value
                    SkattPaAretsResultatRES0Obj = Nothing
                End If
                Dim SkattPaAretsResultatRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:SkattAretsResultat[@contextRef='PERIOD-1']", genbase)
                If Not SkattPaAretsResultatRESm1Obj Is Nothing Then
                    SkattPaAretsResultatRESm1.Text = SkattPaAretsResultatRESm1Obj.ChildNodes(0).Value
                    SkattPaAretsResultatRESm1Obj = Nothing
                End If
                Dim OvrigaSkatterRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaSkatter[@contextRef='PERIOD0']", genbase)
                If Not OvrigaSkatterRES0Obj Is Nothing Then
                    OvrigaSkatterRES0.Text = OvrigaSkatterRES0Obj.ChildNodes(0).Value
                    OvrigaSkatterRES0Obj = Nothing
                End If
                Dim OvrigaSkatterRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:OvrigaSkatter[@contextRef='PERIOD-1']", genbase)
                If Not OvrigaSkatterRESm1Obj Is Nothing Then
                    OvrigaSkatterRESm1.Text = OvrigaSkatterRESm1Obj.ChildNodes(0).Value
                    OvrigaSkatterRESm1Obj = Nothing
                End If
                Dim AretsResultatRES0Obj As XmlNode = root.SelectSingleNode("se-gen-base:AretsResultat[@contextRef='PERIOD0']", genbase)
                If Not AretsResultatRES0Obj Is Nothing Then
                    AretsResultatRES0.Text = AretsResultatRES0Obj.ChildNodes(0).Value
                    AretsResultatRES0Obj = Nothing
                End If
                Dim AretsResultatRESm1Obj As XmlNode = root.SelectSingleNode("se-gen-base:AretsResultat[@contextRef='PERIOD-1']", genbase)
                If Not AretsResultatRESm1Obj Is Nothing Then
                    AretsResultatRESm1.Text = AretsResultatRESm1Obj.ChildNodes(0).Value
                    AretsResultatRESm1Obj = Nothing
                End If


                '' //////////////////// Select nodes inside Tuple //////////////////////////////
                '' Revisionsbyra 1 period 0
                'Dim Revisionsbyra1Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerRevisionsbyra[@contextRef='PERIOD0'])[1]", genbase)
                'If Not Revisionsbyra1Obj Is Nothing Then
                '    Revisionsbyra1.Text = Revisionsbyra1Obj.ChildNodes(0).Value
                '    Revisionsbyra1Obj = Nothing
                'End If
                'Dim RevisionsuppdragRevisionsbyra1RES0Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerRevisionsuppdrag[@contextRef='PERIOD0'])[1]", genbase)
                'If Not RevisionsuppdragRevisionsbyra1RES0Obj Is Nothing Then
                '    RevisionsuppdragRevisionsbyra1RES0.Text = RevisionsuppdragRevisionsbyra1RES0Obj.ChildNodes(0).Value
                '    RevisionsuppdragRevisionsbyra1RES0Obj = Nothing
                'End If
                'Dim OvrigaUppdragRevisionsbyra1RES0Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerOvrigaUppdrag[@contextRef='PERIOD0'])[1]", genbase)
                'If Not OvrigaUppdragRevisionsbyra1RES0Obj Is Nothing Then
                '    OvrigaUppdragRevisionsbyra1RES0.Text = OvrigaUppdragRevisionsbyra1RES0Obj.ChildNodes(0).Value
                '    OvrigaUppdragRevisionsbyra1RES0Obj = Nothing
                'End If
                'Dim SummaRevisionsbyra1RES0Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerSummaRevisionsbyra[@contextRef='PERIOD0'])[1]", genbase)
                'If Not SummaRevisionsbyra1RES0Obj Is Nothing Then
                '    SummaRevisionsbyra1RES0.Text = SummaRevisionsbyra1RES0Obj.ChildNodes(0).Value
                '    SummaRevisionsbyra1RES0Obj = Nothing
                'End If

                '' Revisionsbyra 1 Period -1
                'Dim RevisionsuppdragRevisionsbyra1RESm1Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerRevisionsuppdrag[@contextRef='PERIOD-1'])[1]", genbase)
                'If Not RevisionsuppdragRevisionsbyra1RESm1Obj Is Nothing Then
                '    RevisionsuppdragRevisionsbyra1RESm1.Text = RevisionsuppdragRevisionsbyra1RESm1Obj.ChildNodes(0).Value
                '    RevisionsuppdragRevisionsbyra1RESm1Obj = Nothing
                'End If
                'Dim OvrigaUppdragRevisionsbyra1RESm1Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerOvrigaUppdrag[@contextRef='PERIOD-1'])[1]", genbase)
                'If Not OvrigaUppdragRevisionsbyra1RESm1Obj Is Nothing Then
                '    OvrigaUppdragRevisionsbyra1RESm1.Text = OvrigaUppdragRevisionsbyra1RESm1Obj.ChildNodes(0).Value
                '    OvrigaUppdragRevisionsbyra1RESm1Obj = Nothing
                'End If
                'Dim SummaRevisionsbyra1RESm1Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerSummaRevisionsbyra[@contextRef='PERIOD-1'])[1]", genbase)
                'If Not SummaRevisionsbyra1RESm1Obj Is Nothing Then
                '    SummaRevisionsbyra1RESm1.Text = SummaRevisionsbyra1RESm1Obj.ChildNodes(0).Value
                '    SummaRevisionsbyra1RESm1Obj = Nothing
                'End If

                '' Revisionsbyra 2 period 0
                'Dim Revisionsbyra2Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerRevisionsbyra[@contextRef='PERIOD0'])[2]", genbase)
                'If Not Revisionsbyra2Obj Is Nothing Then
                '    Revisionsbyra2.Text = Revisionsbyra2Obj.ChildNodes(0).Value
                '    Revisionsbyra2Obj = Nothing
                'End If
                'Dim RevisionsuppdragRevisionsbyra2RES0Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerRevisionsuppdrag[@contextRef='PERIOD0'])[2]", genbase)
                'If Not RevisionsuppdragRevisionsbyra2RES0Obj Is Nothing Then
                '    RevisionsuppdragRevisionsbyra2RES0.Text = RevisionsuppdragRevisionsbyra2RES0Obj.ChildNodes(0).Value
                '    RevisionsuppdragRevisionsbyra2RES0Obj = Nothing
                'End If
                'Dim OvrigaUppdragRevisionsbyra2RES0Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerOvrigaUppdrag[@contextRef='PERIOD0'])[2]", genbase)
                'If Not OvrigaUppdragRevisionsbyra2RES0Obj Is Nothing Then
                '    OvrigaUppdragRevisionsbyra2RES0.Text = OvrigaUppdragRevisionsbyra2RES0Obj.ChildNodes(0).Value
                '    OvrigaUppdragRevisionsbyra2RES0Obj = Nothing
                'End If
                'Dim SummaRevisionsbyra2RES0Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerSummaRevisionsbyra[@contextRef='PERIOD0'])[2]", genbase)
                'If Not SummaRevisionsbyra2RES0Obj Is Nothing Then
                '    SummaRevisionsbyra2RES0.Text = SummaRevisionsbyra2RES0Obj.ChildNodes(0).Value
                '    SummaRevisionsbyra2RES0Obj = Nothing
                'End If

                '' Revisionsbyra 2 period -1
                'Dim RevisionsuppdragRevisionsbyra2RESm1Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerRevisionsuppdrag[@contextRef='PERIOD-1'])[2]", genbase)
                'If Not RevisionsuppdragRevisionsbyra2RESm1Obj Is Nothing Then
                '    RevisionsuppdragRevisionsbyra2RESm1.Text = RevisionsuppdragRevisionsbyra2RESm1Obj.ChildNodes(0).Value
                '    RevisionsuppdragRevisionsbyra2RESm1Obj = Nothing
                'End If
                'Dim OvrigaUppdragRevisionsbyra2RESm1Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerOvrigaUppdrag[@contextRef='PERIOD-1'])[2]", genbase)
                'If Not OvrigaUppdragRevisionsbyra2RESm1Obj Is Nothing Then
                '    OvrigaUppdragRevisionsbyra2RESm1.Text = OvrigaUppdragRevisionsbyra2RESm1Obj.ChildNodes(0).Value
                '    OvrigaUppdragRevisionsbyra2RESm1Obj = Nothing
                'End If
                'Dim SummaRevisionsbyra2RESm1Obj As XmlNode = root.SelectSingleNode("(//se-gen-base:ErsattningRevisorerSummaRevisionsbyra[@contextRef='PERIOD-1'])[2]", genbase)
                'If Not SummaRevisionsbyra2RESm1Obj Is Nothing Then
                '    SummaRevisionsbyra2RESm1.Text = SummaRevisionsbyra2RESm1Obj.ChildNodes(0).Value
                '    SummaRevisionsbyra2RESm1Obj = Nothing
                'End If

                '' /////////////////////// Select childnodes with For Each //////////////////////////
                '' Ingaende belopp
                'Dim IngaendebeloppObj As XmlNode = root.SelectSingleNode("se-gen-base:ForandringEgetKapitalBFNTuple[se-gen-base:ForandringEgetKapitalBFNBeloppsslag='Ingende belopp']", genbase)
                'If Not IngaendebeloppObj Is Nothing Then
                '    For Each n As XmlNode In IngaendebeloppObj.ChildNodes
                '        Select Case n.Name
                '            Case "se-gen-base:ForandringEgetKapitalBFNAktiekapital"
                '                IngaendebeloppAktiekapital.Text = n.InnerText
                '            Case "se-gen-base:ForandringEgetKapitalBFNEjRegistreratAktiekapital"
                '                IngaendebeloppEjRegistreratAktiekapital.Text = n.InnerText
                '            Case "se-gen-base:ForandringEgetKapitalBFNUppskrivningsfond"
                '                IngaendebeloppUppskrivningsfond.Text = n.InnerText
                '            Case "se-gen-base:ForandringEgetKapitalBFNReservfond"
                '                IngaendebeloppReservfond.Text = n.InnerText
                '            Case "se-gen-base:ForandringEgetKapitalBFNOverkursfond"
                '                IngaendebeloppOverkursfond.Text = n.InnerText
                '            Case "se-gen-base:ForandringEgetKapitalBFNFondForVerkligtVarde"
                '                IngaendebeloppFondVerkligtVarde.Text = n.InnerText
                '            Case "se-gen-base:ForandringEgetKapitalBFNFrittEgetKapital"
                '                IngaendebeloppFrittEgetKapital.Text = n.InnerText
                '            Case "se-gen-base:ForandringEgetKapitalBFNTotalt"
                '                IngaendebeloppTotalt.Text = n.InnerText
                '        End Select
                '    Next
                'End If

            End If
        End If
    End Sub
    Protected Sub txtBeloppsformat_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txtBeloppsformat.SelectedIndexChanged

        If txtBeloppsformat.SelectedValue = "NORMALFORM" Then
            txtDecimals.Text = "INF"
        Else
            txtDecimals.Text = "-3"
        End If
    End Sub
End Class


